/*
Copyright (C) 1997-2001 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

//g_gametypes.c
extern cvar_t	*g_warmup_enabled;
extern cvar_t	*g_warmup_timelimit;
extern cvar_t	*g_countdown_time;
extern cvar_t	*g_match_extendedtime;
extern cvar_t	*g_gametype_name;

// some game settings
cvar_t	*g_allow_falldamage;

// g_gameteams.c
extern cvar_t	*g_teams_teamdamage;

//testing cvars. To be removed later
cvar_t	*g_ammo_respawn;
cvar_t	*g_armor_respawn;
cvar_t	*g_weapon_respawn;
cvar_t	*g_health_respawn;
cvar_t	*g_powerup_respawn;


typedef struct 
{
	char		*name;
	char		*shortname;
	void		(*initGametype)(void);
	void		(*newMap)(void);
	void		(*checkRules)(void);
	int			(*respawn)(edict_t *ent);
	void		(*clientbegin)(edict_t *ent);
	char		*(*scoreboardMessage) (edict_t *ent, edict_t *killer);

	//time blocks start funcs
	void		(*warmupMatch)(void);
	void		(*countdownMatch)(void);
	void		(*startMatch)(void);
	void		(*endMatch)(void);

	int			spawnableItemsMask;
	int			respawnableItemsMask;

	char		*statusbar;

	//some rules toogles
	qboolean	isTeamBased;
	int			maxPlayersPerTeam;

}gametype_t;

extern gametype_t	gametypes[];


typedef struct
{
	int	playerIndices[MAX_CLIENTS];
	int	numplayers;
	int	teamscore;

}g_teamlist_t;

g_teamlist_t teamlist[GS_MAX_TEAMS];

typedef struct
{
	int		score;
	int		deaths;
	int		kills;
	int		suicides;
	int		teamfrags;

} client_scores_t;

typedef struct matchgame_s
{
	int		state;
	float	starttime;
	float	endtime;
	int		pickableItemsMask;

	qboolean	forceExit;		// just exit, ignore extended time checks
	qboolean	extendedTime;	// match is in extended time period

	qboolean		ready[MAX_CLIENTS];
	client_scores_t scores[MAX_CLIENTS];

}matchgame_t;

extern matchgame_t		match;


//scoreboards string
char	scoreboardString[MAX_STRING_CHARS];
#define SCOREBOARD_MSG_MAXSIZE 512 //I know, I know, doesn't make sense having a bigger string than the maxsize value

//clock
char		clockstring[16];

//
//	matches management
//
void G_Match_RespawnAllItems( void );
void G_Match_RespawnAllClients( void );
void G_Match_CleanUpPlayerStats( edict_t *ent );
void G_Match_FreeBodyQueue( void );

//
//	teams
//
void G_Teams_NewMap( void );
void G_Teams_Init( void );

void G_GameType_ClientHealthRule( void );

void G_GameType_BeginPostMatch( void );





