/*
Copyright (C) 1997-2001 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include "q_shared.h"
#include "gs_public.h"


//============================================================================

/*
================
GS_Obituary

Can be called by either the server or the client
================
*/
void GS_Obituary ( void *victim, int gender, void *attacker, int mod, char *message, char *message2 )
{
	message [0] = 0;
	message2[0] = 0;

	switch (mod)
	{
		case MOD_SUICIDE:
			strcpy ( message, "suicides" );
			break;
		case MOD_FALLING:
			strcpy ( message, "cratered" );
			break;
		case MOD_CRUSH:
			strcpy ( message, "was squished" );
			break;
		case MOD_WATER:
			strcpy ( message, "sank like a rock" );
			break;
		case MOD_SLIME:
			strcpy ( message, "melted" );
			break;
		case MOD_LAVA:
			strcpy ( message, "does a back flip into the lava" );
			break;
		case MOD_EXPLOSIVE:
		case MOD_BARREL:
			strcpy ( message, "blew up" );
			break;
		case MOD_EXIT:
			strcpy ( message, "found a way out" );
			break;
		case MOD_TARGET_LASER:
			strcpy ( message, "saw the light" );
			break;
		case MOD_TARGET_BLASTER:
			strcpy ( message, "got blasted" );
			break;
		case MOD_BOMB:
		case MOD_SPLASH:
		case MOD_TRIGGER_HURT:
			strcpy ( message, "was in the wrong place" );
			break;
	}
	
	if ( attacker == victim ) 
	{
		switch (mod)
		{
		case MOD_HELD_GRENADE:
			strcpy ( message, "tried to put the pin back in" );
			break;
		case MOD_LASER_TRAP:
			if ( gender == GENDER_FEMALE )
				strcpy ( message, "didn't see her own laser trap" );
			else if ( gender == GENDER_MALE )
				strcpy ( message, "didn't see his own laser trap" );
			else
				strcpy ( message, "didn't see its own laser trap" );
			break;
		case MOD_HG_SPLASH:
		case MOD_G_SPLASH:
			if ( gender == GENDER_FEMALE )
				strcpy ( message, "tripped on her own grenade" );
			else if ( gender == GENDER_MALE )
				strcpy ( message, "tripped on his own grenade" );
			else
				strcpy ( message, "tripped on its own grenade" );
			break;
		case MOD_R_SPLASH:
			if ( gender == GENDER_FEMALE )
				strcpy ( message, "blew herself up" );
			else if ( gender == GENDER_MALE )
				strcpy ( message, "blew himself up" );
			else
				strcpy ( message, "blew itself up" );
			break;
		case MOD_BFG_BLAST:
			strcpy ( message, "should have used a smaller gun" );
			break;
		default:
			if ( gender == GENDER_FEMALE )
				strcpy ( message, "killed herself" );
			else if ( gender == GENDER_MALE )
				strcpy ( message, "killed himself" );
			else
				strcpy ( message, "killed itself" );
			break;
		}
	}

	// we already have one
	if ( message[0] ) {
		return;
	}

	if ( attacker ) {
		switch (mod)
		{
		case MOD_BLASTER:
			strcpy ( message, "was blasted by" );
			break;
		case MOD_SHOTGUN:
			strcpy ( message, "was gunned down by" );
			break;
		case MOD_SSHOTGUN:
			strcpy ( message, "was blown away by" );
			strcpy ( message2, "'s super shotgun" );
			break;
		case MOD_MACHINEGUN:
			strcpy ( message, "was machinegunned by" );
			break;
		case MOD_CHAINGUN:
			strcpy ( message, "was cut in half by" );
			strcpy ( message2, "'s chaingun" );
			break;
		case MOD_GRENADE:
			strcpy ( message, "was popped by" );
			strcpy ( message2, "'s grenade" );
			break;
		case MOD_G_SPLASH:
			strcpy ( message, "was shredded by" );
			strcpy ( message, "'s shrapnel" );
			break;
		case MOD_ROCKET:
			strcpy ( message, "ate" );
			strcpy ( message2, "'s rocket" );
			break;
		case MOD_R_SPLASH:
			strcpy ( message, "almost dodged" );
			strcpy ( message2, "'s rocket" );
			break;
		case MOD_HYPERBLASTER:
			strcpy ( message, "was melted by" );
			strcpy ( message2,"'s hyperblaster" );
			break;
		case MOD_RAILGUN:
			strcpy ( message, "was railed by" );
			break;
		case MOD_BFG_LASER:
			strcpy ( message, "saw the pretty lights from" );
			strcpy ( message2, "'s BFG" );
			break;
		case MOD_BFG_BLAST:
			strcpy ( message, "was disintegrated by" );
			strcpy ( message2, "'s BFG blast" );
			break;
		case MOD_BFG_EFFECT:
			strcpy ( message, "couldn't hide from" );
			strcpy ( message2, "'s BFG" );
			break;
		case MOD_HANDGRENADE:
			strcpy ( message, "caught" );
			strcpy ( message2, "'s handgrenade" );
			break;
		case MOD_HG_SPLASH:
			strcpy ( message, "didn't see" );
			strcpy ( message2, "'s handgrenade" );
			break;
		case MOD_HELD_GRENADE:
			strcpy ( message, "feels" );
			strcpy ( message2, "'s pain" );
			break;
		case MOD_TELEFRAG:
			strcpy ( message, "tried to invade" );
			strcpy ( message2, "'s personal space" );
			break;
		case MOD_LASER_TRAP:
			strcpy ( message, "got into" );
			strcpy ( message2, "'s laser trap" );
			break;

		default:
			strcpy ( message, "was killed by" );
			break;
		}
		
		if ( message[0] ) {
			return;
		}
	}

	strcpy ( message, " died." );
}
