/*
Copyright (C) 1997-2001 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include "ui_local.h"

// wsw : jal [start]
//#define NUM_CROSSHAIRS	5
// wsw : jal [end]
/*
=======================================================================

SOUND MENU

=======================================================================
*/

static menuframework_s	s_gfx_menu;

static menuseparator_s	s_gfx_title;
// wsw : jal [start]
//static menulist_s		s_crosshair_box;
// wsw : jal [end]
static menulist_s		s_skyquality_list;
static menulist_s		s_dlights_list;
static menulist_s		s_lightflares_list;
// wsw : jal [start]
//static menulist_s		s_thirdperson_list;
static menulist_s		s_simpleitems_list;
static menulist_s		s_showfps_list;
static menulist_s		s_weaponlist_list;
// wsw : jal [end]
static menulist_s  		s_finish_box;
static menulist_s  		s_marks_list;
// wsw : jal [start]
//static void				*s_crosshair_pic;
//
//static void CrosshairFunc( void *unused )
//{
//	if ( s_crosshair_box.curvalue < 0 || s_crosshair_box.curvalue >= NUM_CROSSHAIRS )
//		trap_Cvar_SetValue( "cg_crosshair", 0 );
//
//	s_crosshair_pic = trap_R_RegisterPic( va("gfx/hud/crosshair%s", s_crosshair_box.itemnames[s_crosshair_box.curvalue]));
//	trap_Cvar_SetValue( "cg_crosshair", s_crosshair_box.curvalue );
//}
// wsw : jal [end]
static void UpdateSkyQualityFunc( void *unused )
{
	trap_Cvar_SetValue( "r_fastsky", !s_skyquality_list.curvalue );
}

static void UpdateDynamicLightsFunc( void *unused )
{
	trap_Cvar_SetValue( "r_dynamiclight", s_dlights_list.curvalue );
}

static void UpdateLightFlaresFunc( void *unused )
{
	trap_Cvar_SetValue( "r_flares", s_lightflares_list.curvalue );
}

// wsw : jal [start]
//static void UpdateThirdPersonFunc( void *unused )
//{
//	trap_Cvar_SetValue( "cg_thirdPerson", s_thirdperson_list.curvalue );
//}
static void UpdateSimpleItemsFunc( void *unused )
{
	trap_Cvar_SetValue( "cg_simpleItems", s_simpleitems_list.curvalue );
}
static void UpdateShowFPSFunc( void *unused )
{
	trap_Cvar_SetValue( "cg_showFPS", s_showfps_list.curvalue );
}
static void UpdateWeaponlistFunc( void *unused )
{
	trap_Cvar_SetValue( "cg_weaponlist", s_weaponlist_list.curvalue );
}
// wsw : jal [end]

static void UpdateFinishFunc( void *unused )
{
	trap_Cvar_SetValue( "gl_finish", s_finish_box.curvalue );
}

static void UpdateMarksFunc( void *unused )
{
	trap_Cvar_SetValue( "cg_decals", s_marks_list.curvalue );
}

void Gfx_MenuInit( void )
{
// wsw : jal [start]
//	static char *crosshair_names[] =
//	{
//		"0", "1", "2", "3", "4", 0
//	};
// wsw : jal [end]
	static char *sky_quality_items[] =
	{
		"fast", "good", 0
	};

	static char *off_on_names[] =
	{
		"off", "on", 0
	};

	int w, h;
	int y = 0;
	int y_offset = UI_StringHeightOffset ( 0 );

	/*
	** configure controls menu and menu items
	*/
	w = uis.vidWidth;
	h = uis.vidHeight;

	s_gfx_menu.x = w / 2;
	s_gfx_menu.nitems = 0;

	s_gfx_title.generic.type = MTYPE_SEPARATOR;
	s_gfx_title.generic.name = "Graphics Options";
	s_gfx_title.generic.flags = QMF_CENTERED|QMF_GIANT;
	s_gfx_title.generic.x    = 0;
	s_gfx_title.generic.y	 = y;
	y+=y_offset;
// wsw : jal [start]
//	s_crosshair_box.generic.type		= MTYPE_SPINCONTROL;
//	//s_crosshair_box.generic.flags		= QMF_NOITEMNAMES;
//	s_crosshair_box.generic.x			= 0;
//	s_crosshair_box.generic.y			= y += y_offset;
//	s_crosshair_box.generic.name		= "crosshair";
//	s_crosshair_box.generic.callback	= CrosshairFunc;
//	s_crosshair_box.itemnames			= crosshair_names;
//	s_crosshair_box.curvalue			= trap_Cvar_VariableValue("cg_crosshair");
//	clamp( s_crosshair_box.curvalue, 0, NUM_CROSSHAIRS - 1 );
//	s_crosshair_pic = trap_R_RegisterPic( va ("gfx/hud/crosshair%s", s_crosshair_box.itemnames[s_crosshair_box.curvalue]));
//	y += y_offset;
// wsw : jal [end]
	s_skyquality_list.generic.type			= MTYPE_SPINCONTROL;
	s_skyquality_list.generic.x				= 0;
	s_skyquality_list.generic.y				= y += y_offset;
	s_skyquality_list.generic.name			= "sky";
	s_skyquality_list.generic.callback		= UpdateSkyQualityFunc;
	s_skyquality_list.itemnames				= sky_quality_items;
	s_skyquality_list.curvalue				= !(int)trap_Cvar_VariableValue( "r_fastsky" );
	clamp ( s_skyquality_list.curvalue, 0, 1 );

	s_dlights_list.generic.type				= MTYPE_SPINCONTROL;
	s_dlights_list.generic.x				= 0;
	s_dlights_list.generic.y				= y += y_offset;
	s_dlights_list.generic.name				= "dynamic lights";
	s_dlights_list.generic.callback			= UpdateDynamicLightsFunc;
	s_dlights_list.itemnames				= off_on_names;
	s_dlights_list.curvalue					= trap_Cvar_VariableValue( "r_dynamiclight" );
	clamp ( s_dlights_list.curvalue, 0, 1 );

	s_lightflares_list.generic.type			= MTYPE_SPINCONTROL;
	s_lightflares_list.generic.x			= 0;
	s_lightflares_list.generic.y			= y += y_offset;
	s_lightflares_list.generic.name			= "light flares";
	s_lightflares_list.generic.callback		= UpdateLightFlaresFunc;
	s_lightflares_list.itemnames			= off_on_names;
	s_lightflares_list.curvalue				= trap_Cvar_VariableValue( "r_flares" );
	clamp ( s_lightflares_list.curvalue, 0, 1 );
// wsw : jal [start]
//	s_thirdperson_list.generic.type			= MTYPE_SPINCONTROL;
//	s_thirdperson_list.generic.x			= 0;
//	s_thirdperson_list.generic.y			= y += y_offset;
//	s_thirdperson_list.generic.name			= "third person view";
//	s_thirdperson_list.generic.callback		= UpdateThirdPersonFunc;
//	s_thirdperson_list.itemnames			= thirdperson_items;
//	s_thirdperson_list.curvalue				= trap_Cvar_VariableValue( "cg_thirdPerson" );
//	clamp ( s_thirdperson_list.curvalue, 0, 1 );

	s_simpleitems_list.generic.type			= MTYPE_SPINCONTROL;
	s_simpleitems_list.generic.x			= 0;
	s_simpleitems_list.generic.y			= y += y_offset;
	s_simpleitems_list.generic.name			= "simple items";
	s_simpleitems_list.generic.callback		= UpdateSimpleItemsFunc;
	s_simpleitems_list.itemnames			= off_on_names;
	s_simpleitems_list.curvalue				= trap_Cvar_VariableValue( "cg_simpleItems" );
	clamp ( s_simpleitems_list.curvalue, 0, 1 );

	s_showfps_list.generic.type			= MTYPE_SPINCONTROL;
	s_showfps_list.generic.x			= 0;
	s_showfps_list.generic.y			= y += y_offset;
	s_showfps_list.generic.name			= "show fps";
	s_showfps_list.generic.callback		= UpdateShowFPSFunc;
	s_showfps_list.itemnames			= off_on_names;
	s_showfps_list.curvalue				= trap_Cvar_VariableValue( "cg_showFPS" );
	clamp ( s_showfps_list.curvalue, 0, 1 );

	s_weaponlist_list.generic.type			= MTYPE_SPINCONTROL;
	s_weaponlist_list.generic.x			= 0;
	s_weaponlist_list.generic.y			= y += y_offset;
	s_weaponlist_list.generic.name			= "HUD weapon list";
	s_weaponlist_list.generic.callback		= UpdateWeaponlistFunc;
	s_weaponlist_list.itemnames			= off_on_names;
	s_weaponlist_list.curvalue				= trap_Cvar_VariableValue( "cg_weaponlist" );
	clamp ( s_weaponlist_list.curvalue, 0, 1 );
// wsw : jal [end]
	s_finish_box.generic.type				= MTYPE_SPINCONTROL;
	s_finish_box.generic.x					= 0;
	s_finish_box.generic.y					= y+=y_offset;
	s_finish_box.generic.name				= "sync every frame";
	s_finish_box.curvalue					= trap_Cvar_VariableValue( "gl_finish" );
	s_finish_box.itemnames					= off_on_names;
	clamp ( s_finish_box.curvalue, 0, 1 );

	s_marks_list.generic.type				= MTYPE_SPINCONTROL;
	s_marks_list.generic.x					= 0;
	s_marks_list.generic.y					= y+=y_offset;
	s_marks_list.generic.name				= "marks on walls";
	s_marks_list.curvalue					= trap_Cvar_VariableValue( "cg_decals" );
	s_marks_list.itemnames					= off_on_names;
	clamp ( s_marks_list.curvalue, 0, 1 );

	Menu_AddItem( &s_gfx_menu, ( void * ) &s_gfx_title );
// wsw : jal [start]
//	Menu_AddItem( &s_gfx_menu, ( void * ) &s_crosshair_box );
// wsw : jal [end]
	Menu_AddItem( &s_gfx_menu, ( void * ) &s_skyquality_list );
	Menu_AddItem( &s_gfx_menu, ( void * ) &s_dlights_list );
	Menu_AddItem( &s_gfx_menu, ( void * ) &s_lightflares_list );
// wsw : jal [start]
	//Menu_AddItem( &s_gfx_menu, ( void * ) &s_thirdperson_list );
	Menu_AddItem( &s_gfx_menu, ( void * ) &s_simpleitems_list );
	Menu_AddItem( &s_gfx_menu, ( void * ) &s_showfps_list );
	Menu_AddItem( &s_gfx_menu, ( void * ) &s_weaponlist_list );
// wsw : jal [end]
	Menu_AddItem( &s_gfx_menu, ( void * ) &s_finish_box );
	Menu_AddItem( &s_gfx_menu, ( void * ) &s_marks_list );

	Menu_Center( &s_gfx_menu );

	Menu_Init ( &s_gfx_menu );
}

void Gfx_MenuDraw (void)
{
	Menu_AdjustCursor( &s_gfx_menu, 1 );
// wsw : jal [start]
//	if ( s_crosshair_pic ) {
//		trap_R_DrawStretchPic ( (int)(BIG_CHAR_WIDTH*1.2) + s_gfx_menu.x + s_crosshair_box.generic.x + (2 * BIG_CHAR_WIDTH),
//			s_gfx_menu.y + s_crosshair_box.generic.y - BIG_CHAR_WIDTH / 2, 32, 32, 
//			0, 0, 1, 1, colorWhite, s_crosshair_pic );
//	}
// wsw : jal [end]
	Menu_Draw( &s_gfx_menu );
}

const char *Gfx_MenuKey( int key )
{
	return Default_MenuKey( &s_gfx_menu, key );
}

void M_Menu_Gfx_f (void)
{
	Gfx_MenuInit();
	M_PushMenu ( &s_gfx_menu, Gfx_MenuDraw, Gfx_MenuKey );
}
